library IEEE;
use IEEE.std_logic_1164.all;

entity Ejemplo_Exhibidores is
   port(
      RST : in  std_logic;                    -- Reset maestro
      CLK : in  std_logic;                    -- Reloj maestro
      H1  : in  std_logic_vector(3 downto 0); -- Entrada 1 
      H0  : in  std_logic_vector(3 downto 0); -- Entrada 0
      P   : in  std_logic;                    -- Entrada punto
      A   : out std_logic_vector(3 downto 0); -- Anodos
      S   : out std_logic_vector(7 downto 1); -- 7 segmentos
      PD  : out std_logic                     -- Punto decimal
      );
   end Ejemplo_Exhibidores;

architecture Muestra of Ejemplo_Exhibidores is

-- Control de los exhibidores de 7 segmentos
component Control_Exhibidores_7s
   port(
      RST : in  std_logic;                    -- Reset maestro
      CLK : in  std_logic;                    -- Reloj maestro
      H3  : in  std_logic_vector(3 downto 0); -- Entrada 3
      H2  : in  std_logic_vector(3 downto 0); -- Entrada 2
      H1  : in  std_logic_vector(3 downto 0); -- Entrada 1 
      H0  : in  std_logic_vector(3 downto 0); -- Entrada 0
      P   : in  std_logic_vector(3 downto 0); -- Entrada puntos
      A   : out std_logic_vector(3 downto 0); -- Anodos
      S   : out std_logic_vector(7 downto 1); -- 7 segmentos
      PD  : out std_logic                     -- Punto decimal
      );
   end component;

-- Vector de puntos decimales
signal D      : std_logic_vector(3 downto 0);

-- Complemento de dos exhibidores
signal H3, H2 : std_logic_vector(3 downto 0);

begin

   -- Interconectividad
   D  <= P & P & P & P;
   H3 <= NOT(H1);
   H2 <= NOT(H0);

   -- Control de los exhibidores de 7 segmentos
   DUT_01: Control_Exhibidores_7s port map(RST,CLK,H3,H2,H1,H0,D,A,S,PD);

end Muestra;