library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity Modulo_10000 is
   port(
      RST : in  std_logic; -- Reset maestro
      CLK : in  std_logic; -- Reloj maestro
      Q   : out std_logic  -- Cero
      );
   end Modulo_10000;

architecture Cascada of Modulo_10000 is

-- Estados internos
signal Qp, Qn : std_logic_vector(13 downto 0);

-- Detector de 9999
signal Z      : std_logic;

-- Incrementador
signal I      : std_logic_vector(13 downto 0);

begin

   Detector: process(Qp)
   begin
      Z <=                               NOT(Qp(13)) OR     Qp(12) OR
               Qp(11)  OR NOT(Qp(10)) OR NOT(Qp(9))  OR NOT(Qp(8)) OR
               Qp(7)   OR     Qp(6)   OR     Qp(5)   OR     Qp(4)  OR
           NOT(Qp(3))  OR NOT(Qp(2))  OR NOT(Qp(1))  OR NOT(Qp(0));
   end process Detector;

   Incrementador: process(Qp)
   begin
      I <= Qp + 1;
   end process Incrementador;

   Anulador: process(Z,I)
   begin
      for j in 0 to 13 loop
         Qn(j) <= Z AND I(j);
      end loop;
      Q <= NOT(Z);
   end process Anulador;

   Secuencial: process(RST,CLK)
   begin
      if (RST='1') then
         Qp <= (others => '0');
      elsif (CLK'event and CLK='1') then 
         Qp <= Qn;
      end if;
   end process Secuencial;

end Cascada;
