library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity Modulo_4 is
   port(
      RST : in  std_logic;                    -- Reset maestro
      CLK : in  std_logic;                    -- Reloj maestro
      H   : in  std_logic;                    -- Habilitacion de entrada
      Q   : out std_logic_vector(1 downto 0)  -- Salida
      );
   end Modulo_4;

architecture Cascada of Modulo_4 is

-- Estados internos
signal Qp, Qn : std_logic_vector(1 downto 0);

begin

   Combinacional: process(H,Qp)
   begin
      if (H='1') then
         Qn <= Qp + 1;
      else
         Qn <= Qp;
      end if;
      Q <= Qp;
   end process Combinacional;

   Secuencial: process(RST,CLK)
   begin
      if (RST='1') then
         Qp <= (others => '0');
      elsif (CLK'event and CLK='1') then 
         Qp <= Qn;
      end if;
   end process Secuencial;

end Cascada;
