library IEEE;
use IEEE.std_logic_1164.all;

entity Ejemplo_VGA_1 is
   port(
      RST : in  std_logic;                    -- Reset maestro
      CLK : in  std_logic;                    -- Reloj maestro
      KLR : in  std_logic_vector(2 downto 0); -- Color VGA
      VS  : out std_logic;                    -- Sincronia vertical
      HS  : out std_logic;                    -- Sincronia horizontal
      R   : out std_logic;                    -- Red
      G   : out std_logic;                    -- Green
      B   : out std_logic                     -- Blue
      );
   end Ejemplo_VGA_1;

architecture Prueba of Ejemplo_VGA_1 is

-- Sincronizador VGA
component Sincronizador_VGA
   port(
      RST : in  std_logic;                    -- Reset maestro
      CLK : in  std_logic;                    -- Reloj maestro
      VS  : out std_logic;                    -- Sincronia vertical
      HS  : out std_logic;                    -- Sincronia horizontal
      VAD : out std_logic_vector(8 downto 0); -- Direccion vertical
      HAD : out std_logic_vector(9 downto 0); -- Direccion horizontal
      EDS : out std_logic                     -- Habilitacion pixel
      );
   end component;

-- Habilitacion de pixel
signal EDS: std_logic;

-- Direccion de pixel (no utilizadas en este ejemplo)
signal VAD: std_logic_vector(8 downto 0);
signal HAD: std_logic_vector(9 downto 0);

begin

   -- Sincronizador VGA
   DUT_01: Sincronizador_VGA port map(RST,CLK,VS,HS,VAD,HAD,EDS);

   -- Salida de pixel
   R <= KLR(2) AND EDS;
   G <= KLR(1) AND EDS;
   B <= KLR(0) AND EDS;

end Prueba;
