library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity Genera_Barras is
   port(
      RST : in  std_logic;                     -- Reset maestro
      CLK : in  std_logic;                     -- Reloj maestro
      STG : in  std_logic_vector(1  downto 0); -- Control del generador
      EOG : out std_logic;                     -- Fin de generacion
      BAR : out std_logic_vector(17 downto 0); -- Direccion de la barra
      KLR : out std_logic_vector(5  downto 0)  -- Colores de la barra
      );
   end Genera_Barras;

architecture Contador of Genera_Barras is

-- Estados internos
signal Qp, Qn : std_logic_vector(17 downto 0);

begin

   Combinacional: process(STG,Qp)
   begin
      case STG is
         when "11"   => Qn <= (others => '0');
         when "10"   => Qn <= Qp + 1;
         when others => Qn <= Qp;
      end case;
      if (Qp="111111111111111111") then
         EOG <= '1';
      else
         EOG <= '0';
      end if;
      BAR <= Qp;
      KLR <= Qp(6 downto 4) & Qp(6 downto 4);
   end process Combinacional;

   Secuencial: process(RST,CLK)
   begin
      if (RST='1') then
         Qp <= (others => '0');
      elsif (CLK'event and CLK='1') then
         Qp <= Qn;
      end if;
   end process Secuencial;

end Contador;