library IEEE;
use IEEE.std_logic_1164.all;

entity Desplegado_H is
   port(
      RST : in  std_logic; -- Reset maestro
      CLK : in  std_logic; -- Reloj maestro
      ST  : in  std_logic; -- Habilitacion de entrada
      HIC : out std_logic  -- Habilitacion de linea
      );
   end Desplegado_H;

architecture Cascada of Desplegado_H is

-- Estados internos
signal Qp, Qn : std_logic;

-- Detector de 1
signal Z      : std_logic;

-- Incrementador
signal I      : std_logic;

begin

   Detector: process(Qp)
   begin
      if (Qp='1') then
         Z <= '0';
      else
         Z <= '1';
      end if;
   end process Detector;

   Incrementador: process(Qp)
   begin
      I <= NOT(Qp);
   end process Incrementador;

   Anulador: process(Z,I,ST)
   begin
      Qn  <= ST AND Z AND I;
      HIC <= NOT(Z) AND ST;
   end process Anulador;

   Secuencial: process(RST,CLK)
   begin
      if (RST='1') then
         Qp <= '0';
      elsif (CLK'event and CLK='1') then 
         Qp <= Qn;
      end if;
   end process Secuencial;

end Cascada;